*---------------------------------------------------------
* File      : gastransprices.inc
* Author    :
* Version   : 1.0
* Remarks   : #
* Date      : 17/11/2005 09:46:23
* Changed   : 13-04-2006 15:28:41
* Changed by:
*---------------------------------------------------------

*
*        ACCESS COSTS IN THE NATURAL GAS SYSTEM
*

* Distribution
PARAMETER TAU_DIST(DDD) /
DONG_OEST    20.91
DONG_VEST    20.91
NGF          19.09
MIDT_NORD    20.27
HNG          20.27
SE_S_DIST    20.91
/;



* Transmission
TAU_VOL = 1.48;

* TAU_FLEX sat til store-M
PARAMETER TAU_EX_FLEX(SYSEXIT) 'Cost of fleksible EXIT capacity'
/
Oeresund  99999
Ellund    99999
DK-EXIT   99999
/;

PARAMETER TAU_EN_FLEX(SYSENTRY) 'Cost of fleksible EXIT capacity'
/
Nybro     99999
Ellund    99999
Oresund   99999
/;

PARAMETER TAU_EN_Y 'Cost of annual exit capacity (kr/MW/h/year)'
/
14010.00
/;

PARAMETER TAU_EX_Y 'Cost of annual exit capacity (kr/MW/h/year)'
/
14010.00
/;


PARAMETER TAU_EN_M(IMONTH) 'Cost of monthly entry capacity (kr/MW/h/month)'
* Data entry as fraction of annual capacity contract
/
JAN        0.35
FEB        0.35
MAR        0.30
APR        0.15
MAY        0.08
JUN        0.08
JUL        0.08
AUG        0.08
SEP        0.08
OCT        0.10
NOV        0.15
DEC        0.30
/;
TAU_EN_M(IMONTH) = TAU_EN_M(IMONTH)*TAU_EN_Y;

PARAMETER TAU_EX_M(IMONTH) 'Cost of monthly exit capacity (kr/MW/h/month)'
* Data entry as fraction of annual capacity contract
/
JAN       0.35
FEB       0.35
MAR       0.30
APR       0.15
MAY       0.08
JUN       0.08
JUL       0.08
AUG       0.08
SEP       0.08
OCT       0.10
NOV       0.15
DEC       0.30
/;
TAU_EX_M(IMONTH) = TAU_EX_M(IMONTH)*TAU_EX_Y;

PARAMETER TAU_EN_W(SSS)                        'Cost of weekly entry capacity (kr/MW/h/week)'
* Data entry as fraction of annual capacity contract
/
S01        0.98
S02        0.98
S03        0.98
S04        0.98
S05        0.98
S06        0.98
S07        0.98
S08        0.98
S09        0.08
S10        0.08
S11        0.08
S12        0.08
S13        0.08
S14        0.04
S15        0.04
S16        0.04
S17        0.04
S18        0.025
S19        0.025
S20        0.025
S21        0.025
S22        0.025
S23        0.025
S24        0.025
S25        0.025
S26        0.025
S27        0.025
S28        0.025
S29        0.025
S30        0.025
S31        0.025
S32        0.025
S33        0.025
S34        0.025
S35        0.025
S36        0.025
S37        0.025
S38        0.025
S39        0.025
S40        0.028
S41        0.028
S42        0.028
S43        0.028
S44        0.04
S45        0.04
S46        0.04
S47        0.04
S48        0.04
S49        0.08
S50        0.08
S51        0.08
S52        0.08
/;
TAU_EN_W(SSS) = TAU_EN_W(SSS) *TAU_EN_Y;

PARAMETER TAU_EX_W(SSS)                        'Cost of weekly exit capacity (kr/MW/h/week)'
* Data entry as fraction of annual capacity contract
/
S01        0.98
S02        0.98
S03        0.98
S04        0.98
S05        0.98
S06        0.98
S07        0.98
S08        0.98
S09        0.08
S10        0.08
S11        0.08
S12        0.08
S13        0.08
S14        0.04
S15        0.04
S16        0.04
S17        0.04
S18        0.025
S19        0.025
S20        0.025
S21        0.025
S22        0.025
S23        0.025
S24        0.025
S25        0.025
S26        0.025
S27        0.025
S28        0.025
S29        0.025
S30        0.025
S31        0.025
S32        0.025
S33        0.025
S34        0.025
S35        0.025
S36        0.025
S37        0.025
S38        0.025
S39        0.025
S40        0.028
S41        0.028
S42        0.028
S43        0.028
S44        0.04
S45        0.04
S46        0.04
S47        0.04
S48        0.04
S49        0.08
S50        0.08
S51        0.08
S52        0.08
/;
TAU_EX_W(SSS) = TAU_EX_W(SSS)*TAU_EX_Y;

TABLE TAU_EN_D(SSS, DAY)                        'Cost of daily entry capacity (kr/MW/h/day)'
* Data entry as fraction of annual capacity contract
           MONDAY        TUESDAY       WEDNESDAY     THURSDAY      FRIDAY        SATURDAY      SUNDAY
S01        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S02        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S03        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S04        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S05        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S06        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S07        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S08        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S09        0.0250        0.0250        0.0250        0.0210        0.0210        0.0210        0.0210
S10        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S11        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S12        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S13        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0125
S14        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S15        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S16        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S17        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S18        0.0125        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S19        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S20        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S21        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S22        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S23        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S24        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S25        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S26        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S27        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S28        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S29        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S30        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S31        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S32        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S33        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S34        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S35        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S36        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S37        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S38        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S39        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S40        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S41        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S42        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S43        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S44        0.0095        0.0095        0.0095        0.0125        0.0125        0.0125        0.0125
S45        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S46        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S47        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S48        0.0125        0.0125        0.0125        0.0125        0.0125        0.0210        0.0210
S49        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S50        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S51        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S52        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
;
TAU_EN_D(SSS, DAY) = TAU_EN_D(SSS, DAY)*TAU_EN_Y;

TABLE TAU_EX_D(SSS,DAY)                        'Cost of daily exit capacity (kr/MW/h/day)'
* Data entry as fraction of annual capacity contract
        MONDAY        TUESDAY        WEDNESDAY        THURSDAY        FRIDAY        SATURDAY        SUNDAY
S01        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S02        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S03        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S04        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S05        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S06        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S07        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S08        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250        0.0250
S09        0.0250        0.0250        0.0250        0.0210        0.0210        0.0210        0.0210
S10        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S11        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S12        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S13        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0125
S14        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S15        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S16        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S17        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S18        0.0125        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S19        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S20        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S21        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S22        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S23        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S24        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S25        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S26        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S27        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S28        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S29        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S30        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S31        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S32        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S33        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S34        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S35        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S36        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S37        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S38        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S39        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074        0.0074
S40        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S41        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S42        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S43        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095        0.0095
S44        0.0095        0.0095        0.0095        0.0125        0.0125        0.0125        0.0125
S45        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S46        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S47        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125        0.0125
S48        0.0125        0.0125        0.0125        0.0125        0.0125        0.0210        0.0210
S49        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S50        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S51        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
S52        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210        0.0210
;
TAU_EX_D(SSS,DAY) = TAU_EX_D(SSS,DAY)*TAU_EX_Y;