* File: inputout.inc




* This file will generate various presentations of the input
* to the Balmorel model.
* The input is presented here in various ways that may facilitate
* overview, control and error finding.
* The information presented here is intended to be produced before
* any optimisation or simulation has taken place
* but after the internal processing has taken place.
* Therefore the "$INCLUDE INPUTOUT.INC" statement should be placed
* immediately before the start of the Annual Updating Part in Balmorel.gms.
* The amount of output generated by the present file is quite large,
* it requires some computation time, and therefore
* it may be expedient to include it only when review of input data is desired.
* If you are interested in studying the output generated by inputout.inc
* the SOLVE statement may be commented out in the Balmorel.gms file to save
* computation time and avoid related execution errors.
* However, other print files assume that the SOLVE statement is present,
* and if the SOLVE statement is commented out then also at least
* "$INCLUDE prt4-bb1.inc" should be commented out in the Balmorel.gms file.





FILE inputout /..\output\inputout\inputout.out/;


PUT inputout;
INPUTOUT.PW = 32000;
PUT "Version:      " SYSTEM.TITLE /;
PUT "File created: " SYSTEM.DATE " " SYSTEM.TIME //;
PUT "This file presents an overview of various input data to the Balmorel model." //;
PUT "The information presented here is independent of simulation or optimisation, " /;
PUT "and is therefore only an alternative presentation of the input data. "//;

PUT "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "+++             THIS FILE IS NOT FINISHED - THERE MAY BE ERRORS                         +++" /;
PUT "+++     (Last revised by hr 2003.09.05, 2004.04.19, 2005.07.31, 2005.10.31, 2008.xy     +++" /;
PUT "+++     (20090324,                                                                 )    +++" /;
PUT "+++                                Note carefully:                                      +++" /;
PUT "+++      The present file does not reflect changes for Balmorel versions after 2.12     +++" /;
PUT "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" //;






* End preliminaries
PUT "The following information is printed: "//;

PUT "--------------------------------------------------------------------------------" /;
PUT "----------------------------- Section (10): ----------------------------------- "/;
PUT "Geography. " /;

PUT "----------------------------- Section (50): ----------------------------------- "/;
PUT "Relative to time: " /;
PUT "   Years to be simulated, startyear "  /;
PUT "   The subdivision of the year into time segments (S,T)"/;


PUT "----------------------------- Section (100): ---------------------------------- "/;
PUT "Relative to demand: " /;
PUT "   Nominal electricity demand over time segments: maximum (MW),";
PUT " percentage relative to maximum, and percentage of annual energy:" /;
PUT "   Nominal heat demand over time segments: maximum (MW),";
PUT " percentage relative to maximum, and percentage of annual energy:" /;



PUT "----------------------------- Section (200): ---------------------------------- "/;
PUT "Relative to distribution: " /;
PUT "   Loss and cost in electricity distribution " /;
PUT "   Loss and cost in heat distribution " /;


PUT "----------------------------- Section (300): ---------------------------------- "/;
PUT "Relative to policy: " /;
PUT "   (Nothing yet.)" /;


PUT "----------------------------- Section (400): ---------------------------------- "/;
PUT "Relative to generation: " /;
PUT "   Techologies by type "/;
PUT "   Nominal electricity generation capacities (sum)(MW), by (Y,C)" /;
PUT "   Derated electricity generation capacities (sum)(MW), by (Y,C)" /;
PUT "   Nominal electricity generation capacities (sum)(MW), by (Y,IR)" /;
PUT "   Nominal electricity generation capacities (MW), by (Y,C)   " /;
PUT "   Nominal condensing generation capacities (MW), by (Y,C) " /;
PUT "   Nominal CHP generation capacities (MW), by (Y,C)        " /;
PUT "   Heat storage capacities: storage (MWh), loading (MW) and unloading (MW)" /;
PUT "   Electricity storage capacities: storage (MWh), loading (MW) and unloading (MW)" /;
PUT "   Full load hours for renewable energies, comparison between FLH and VAR values"/;
PUT "   Hydro power: Storage capacity (GWh), nominal water energy available one year (GWh) and hydro power capacity (MW), by IR "  /;
PUT "   Hydro power with storage:  Maximal and minimal storage capacity limits (GWh), by (IR,S) "/;
PUT "   Hydro power run-of-river:  Inflow (GWh), by (IR,S) "/;
PUT "   Hydro power with reservoir:   Inflow (GWh), by (IR,S) "/;
PUT "   Nominal hydro power with pumped storage capacities"  /;
PUT "   Nominal hydro power with reservoir: Water energy available (GWh)" " and hydro power capacity (MW) " /;
PUT "   Nominal hydro power with reservoir capacities (MW), by (Y,C)"/;
PUT "   Nominal wind energy available (GWh) and wind power capacity (MW) " /;
PUT "   Nominal wind power capacities (MW), by (Y,C)"/;
PUT "   Nominal heat capacities (including CHP)(sum)(MW), by (Y,C)" /;
PUT "   Nominal heat capacities (including CHP)(sum)(MW), by (Y,IA) " /;
PUT "   Nominal electricity capacities of CHP (MW), by (Y,IA) " /;
PUT "   Nominal heat capacities of CHP (MW), by (Y,IA) " /;
PUT "   Nominal heat boiler capacities (sum)(MW), by (Y,C)        " /;
PUT "   Nominal heat pump capacities (sum)(MW), by (Y,C)     " /;
PUT "   Nominal heat boiler capacities (sum)(MW), by (Y,IA)      " /;
PUT "   Nominal heat pump capacities (sum)(MW), by (Y,IA)        " /;
PUT "   (Economy for generation technologies. )" /;
PUT "   Technologies available or not available for new investments"  /;
PUT "   Description of when new technologies may be invested" /;
PUT "   Description of where new technologies may be invested"  /;


PUT /;

PUT "----------------------------- Section (500): ---------------------------------- "/;
PUT "Relative to fuel: " /;
PUT "   Fuel potentials by (F,C) and already installed by (Y,F,C)" /;
PUT "   Fuel potentials by (F,IR) and already installed by (Y,F,IR)" /;
PUT "   Fuel potentials by (F,IA) and already installed by (Y,F,IA)" /;
PUT "   Description of the fuel that each technology uses" /;
PUT "   Exogenously specified technology capacities by fuel and country"  /;
PUT "   Exogenously specified technology capacities by fuel and area"  /;



PUT "----------------------------- Section (600): ---------------------------------- "/;
PUT "Relative to economy: "/;
PUT "   The currency used in output"/;
PUT "   Variable costs of electricity generation on installed capacities" /;
PUT "   Variable costs of heat generation on installed capacities (IGKH)" /;
PUT "   A supply curve for electricity"/;
PUT /;


PUT "----------------------------- Section (700): ---------------------------------- "/;
PUT "Relative to electricity transmission: " /;
PUT "   Transmission capacites (MW)." /;
PUT "   Possibilities for new transmission capacities and associated costs (Money/MW)."/;
PUT "--------------------------------------------------------------------------------" /;

PUT ///;




PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "START OF TABLES : " /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT /;

PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "----------------------------- Section (10): ----------------------------------- "/;
PUT "Geography: " /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT /;

PUT "The countries simulated:"/
LOOP(C, PUT C.TL:12; IF((MOD(ORD(C),7) EQ 0), PUT /;) );
PUT //;



PUT "The geographical extension simulated is subdivided as follows: " /;


LOOP(C,
PUT "Country " C.TL "   is subdivided into regions and areas as follows: " /;
LOOP(IR$CCCRRR(C,IR),
PUT "   Region " IR.TL " is subdivided into areas as follows:" /;
LOOP(IA$RRRAAA(IR,IA),
PUT IA.TL ); PUT /;
)
PUT /;
);
PUT /;


PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "----------------------------- Section (50): ----------------------------------- "/;
PUT "Information relative to time: " /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT /;



PUT "--------------------------------------------------------------------------------" /;
PUT "Years to be simulated, startyear: "  /;
PUT "--------------------------------------------------------------------------------" /;

* Years to be simulated, startyear:
PUT "The years to be simulated, i.e. those in SET Y are: " ; LOOP(Y, PUT Y.TL:5:0  ); PUT //;


PUT "--------------------------------------------------------------------------------" /;
PUT "The subdivision of the year into time segments (S,T) is as follows: "/;
PUT "--------------------------------------------------------------------------------" /;


INPUTOUT.LJ=1;
* Seasons to be simulated:
PUT "The seasons in SET S and their duration: " / ;
PUT "Name:  "; LOOP(S, PUT S.TL:12); PUT /;
PUT "Days:  "; LOOP(S, PUT IDAYSIN_S(S):12:1  ); PUT //;


* "Hours"  to be simulated:
PUT "The time segments in SET T and their duration" " (if a season had 24 hours' duration):   " /;
PUT "Name:  "; LOOP(T, PUT T.TL:12); PUT /;
PUT "Hours: "; LOOP(T, PUT IHOURSIN24(T):12:1  );
PUT //;



PUT "The length of the time segments (S,T) has a duration that is equal to "/;
PUT "the product of the durations of the element in S and the element in T."/;
PUT "For the first time segment of the year, for instance, this is equal to ";
LOOP((S,T)$((ORD(S) EQ 1) AND (ORD(T) EQ 1)),
PUT (IDAYSIN_S(S)*IHOURSIN24(T)):6:1 " hours."/ );
* same as:  PUT ( IHOURSINst(s,T)):6:1 " hours."/ );
PUT /;

PUT "The complete table of the lengths (hours per year) of the time segments (S,T): "//;
PUT "               ";
LOOP(S$(ORD(S) LE 100), PUT  S.TL:8 ;) PUT /;
LOOP(T,
PUT T.TL:15;
LOOP(S, PUT (IDAYSIN_S(S)*IHOURSIN24(T)):8:1); PUT /;
);
PUT //;

*$ontext
PUT "If each season were of duration 24 hours, then the length in hour T in a season would be as follows. "/;
PUT "(Usefull in relation to short term storages that are assumed to be working on a daily basis, "/;
PUT "although cyclical within each season, which need not be of 24 hours' duration.)"//;

PUT "               ";
LOOP(S$(ORD(S) LE 100), PUT  S.TL:8 ;) PUT /;
LOOP(T,
PUT T.TL:15;
LOOP(S, PUT ( IHOURSIN24(T)):8:1); PUT /;
);
PUT //;
*$offtext



PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "----------------------------- Section (100): -----------------------------------"/;
PUT "Tables relative to demand: "  /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT /;






* Demand profiles
PUT "--------------------------------------------------------------------------------" /;
PUT "Nominal electricity demand over time segments:" /;
PUT "  - maximum (MW)" /;
PUT "  - percentage relative to maximum" /;
PUT "  - percentage of annual energy" /;
PUT " (No indexes (S,T) shown. Index S runs slower, index T runs faster." /;
PUT " If there are many time segments, only the first ones are shown.) "/;
PUT "--------------------------------------------------------------------------------" //;

INPUTOUT.LJ=2;
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
OSCALAR3= SMAX((S,T),DE_VAR_T(IR,S,T) );
LOOP(Y$(ORD(Y) EQ 1),
PUT IR.TL ":   Maximum load (MW) in the first year of simulation: "    (DE(Y,IR)*OSCALAR3/IDE_SUMST(IR)):10:0 /;
);
PUT "   MW:  ";
OSCALAR1=30; /* Maximum number of time segments printed */
OSCALAR2=0;
LOOP(S,
LOOP(T,
OSCALAR2=OSCALAR2+1;
IF(OSCALAR2 LE OSCALAR1,
PUT (100*DE_VAR_T(IR,S,T)/OSCALAR3):6:1   ;
IF(ORD(T) EQ CARD(T),   PUT "   "; ))));PUT /;
PUT "   MWh: ";
OSCALAR2=0;
LOOP(S,
LOOP(T,
OSCALAR2=OSCALAR2+1;
IF(OSCALAR2 LE OSCALAR1,
PUT (100*IDAYSIN_S(S)*IHOURSIN24(T)*DE_VAR_T(IR,S,T)/IDE_SUMST(IR)):6:1   ;
IF(ORD(T) EQ CARD(T), PUT "   "; )))); PUT /;
)); PUT ///;



PUT "--------------------------------------------------------------------------------" /;
PUT "Electricity demand (GWh), first and last years in simulation period:" /;
PUT "--------------------------------------------------------------------------------" /;

PUT "                    ";
  LOOP(Y$(ORD(Y) EQ 1), PUT Y.TL:12);
  LOOP(Y$(ORD(Y) EQ CARD(Y)), PUT Y.TL:12);PUT /;
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
PUT IR.TL ;
  LOOP(Y$(ORD(Y) EQ 1), PUT (1E-3*DE(Y,IR)):12:0);
  LOOP(Y$(ORD(Y) EQ CARD(Y)), PUT (1e-3*DE(Y,IR)):12:0);PUT /;
));
PUT //;




PUT "--------------------------------------------------------------------------------" /;
PUT "Heat demand (GWh), first and last years in simulation period:" /;
PUT "--------------------------------------------------------------------------------" /;

PUT "                    ";
  LOOP(Y$(ORD(Y) EQ 1), PUT Y.TL:12);
  LOOP(Y$(ORD(Y) EQ CARD(Y)), PUT Y.TL:12);PUT /;
LOOP(C,
LOOP(IA$ICA(C,IA),
PUT IA.TL ;
  LOOP(Y$(ORD(Y) EQ 1), PUT (1E-3*DH(Y,IA)):12:0);
  LOOP(Y$(ORD(Y) EQ CARD(Y)), PUT (1e-3*DH(Y,IA)):12:0);PUT /;
));
PUT //;



PUT "--------------------------------------------------------------------------------" /;
PUT "Nominal heat demand over time segments:" /;
PUT "  - maximum (MW)" /;
PUT "  - percentage relative to maximum" /;
PUT "  - percentage of annual energy:" /;
PUT "(No indexes (S,T) shown. Index S runs slower, index T runs faster. " /;
PUT "If there are many time segments, only the first ones are shown.) "/;
PUT "--------------------------------------------------------------------------------" //;

INPUTOUT.LJ=2;
LOOP(C,
LOOP(IA$ICA(C,IA),
OSCALAR3= SMAX((S,T),DH_VAR_T(IA,S,T) );
LOOP(Y$(ORD(Y) EQ 1),
PUT IA.TL ":   Maximum load (MW) in the first year of simulation: "    (DH(Y,IA)*OSCALAR3/IDH_SUMST(IA)):10:0 /;
);
PUT "   MW:  ";
OSCALAR1=30; /* Maximum number of time segments printed */
OSCALAR2=0;
OSCALAR3= SMAX((S,T),DH_VAR_T(IA,S,T) );LOOP(S,
LOOP(T,
OSCALAR2=OSCALAR2+1;
IF(OSCALAR2 LE OSCALAR1,
PUT (100*DH_VAR_T(IA,S,T)/OSCALAR3):6:1   ;
IF(ORD(T) EQ CARD(T),   PUT "   ";  ))));PUT /;
PUT "   MWh: ";
OSCALAR2=0;
LOOP(S,
LOOP(T,
OSCALAR2=OSCALAR2+1;
IF(OSCALAR2 LE OSCALAR1,
PUT (100*IDAYSIN_S(S)*IHOURSIN24(T)*DH_VAR_T(IA,S,T)/IDH_SUMST(IA)):6:1   ;
IF(ORD(T) EQ CARD(T),   PUT "   ";)))); PUT /;
)); PUT ///;



PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "----------------------------- Section (200): -----------------------------------"/;
PUT "Tables relative to distribution: "  /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT /;

LOOP(Y$(ORD(Y) EQ 1),
PUT "--------------------------------------------------------------------------------" /;
PUT "Loss in electricity distribution:" /;
PUT " - percentage of electricity entering the distribution network "/;
PUT " - percentage of consumption" /;
PUT " - quantity (relative to nominal demand) in first year (" Y.TL:4 ")" /;
PUT " - cost" /;
PUT "--------------------------------------------------------------------------------" //;

PUT "                       %           %         MWh   EUR90/MWh" /;
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
PUT IR.TL:12   (100*DISLOSS_E(IR)):12:2  (100*DISLOSS_E(IR)/(1-DISLOSS_E(IR))):12:2;
PUT (DE(Y,IR)*(DISLOSS_E(IR)/(1-DISLOSS_E(IR)))):12:0   DISCOST_E(IR):12:2             /;
))
PUT //;


PUT "--------------------------------------------------------------------------------"/;
PUT "Loss in heat distribution:" /;
PUT " - percentage of heat entering the distribution network" /;
PUT " - percentage of consumption" /;
PUT " - quantity (relative to nominal demand) in first year (" Y.TL:4 ")" /;
PUT " - cost" /;
PUT "--------------------------------------------------------------------------------"//;


PUT "                       %           %         MWh   EUR90/MWh" /;
LOOP(C,
LOOP(IA$ICA(C,IA),
PUT IA.TL:12   (100*DISLOSS_H(IA)):12:2  (100*DISLOSS_H(IA)/(1-DISLOSS_H(IA))):12:2;
PUT (DH(Y,IA)*(DISLOSS_H(IA)/(1-DISLOSS_H(IA)))):12:0   DISCOST_H(IA):12:2             /;
)));
PUT //;





PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT "----------------------------- Section (400): -----------------------------------"/;
PUT "Tables relative to generation: " /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" /;
PUT /;


* List of the technologies, classified by type:

PUT "------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;
PUT "Technologies by type: "/;
PUT "------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;

PUT IGCND.TS":"/;    PUT "   ";
LOOP(IGCND, PUT IGCND.TL:OTLG ); PUT /;
PUT IGBPR.TS":"/;    PUT "   ";
LOOP(IGBPR, PUT IGBPR.TL:OTLG ); PUT /;
PUT IGEXT.TS":"/;    PUT "   ";
LOOP(IGEXT, PUT IGEXT.TL:OTLG ); PUT /;
PUT IGHOB.TS":"/;    PUT "   ";
LOOP(IGHOB, PUT IGHOB.TL:OTLG ); PUT /;
PUT IGETOH.TS":"/;    PUT "   ";
LOOP(IGETOH, PUT IGETOH.TL:OTLG ); PUT /;
PUT IGHSTO.TS":"/;   PUT "   ";
LOOP(IGHSTO, PUT IGHSTO.TL:OTLG );PUT /;
PUT IGESTO.TS":"/;   PUT "   ";
LOOP(IGESTO, PUT IGESTO.TL:OTLG );PUT /;
PUT IGHYRS.TS":"/;    PUT "   ";
LOOP(IGHYRS, PUT IGHYRS.TL:OTLG ); PUT /;
PUT IGHYRR.TS":"/;    PUT "   ";
LOOP(IGHYRR, PUT IGHYRR.TL:OTLG ); PUT /;
PUT IGWND.TS":"/;    PUT "   ";
LOOP(IGWND, PUT IGWND.TL:OTLG ); PUT /;
PUT IGSOLE.TS":"/;    PUT "   ";
LOOP(IGSOLE, PUT IGSOLE.TL:OTLG ); PUT /;
PUT / "Derived types: "/;
PUT IGEE.TS ":"/;
LOOP(IGEE, PUT IGEE.TL:OTLG ); PUT /;
PUT IGHH.TS ":"/;
LOOP(IGHH, PUT IGHH.TL:OTLG ); PUT /;
PUT IGKH.TS ":"/;
LOOP(IGKH, PUT IGKH.TL:OTLG ); PUT /;
PUT IGKE.TS ":"/;
LOOP(IGKE, PUT IGKE.TL:OTLG ); PUT /;
PUT IGDISPATCH.TS ":"/;
LOOP(IGDISPATCH, PUT IGDISPATCH.TL:OTLG ); PUT //;

PUT "------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;
PUT //;


* A table containing the sum of nominal (i.e. no derating is considered)
* electricity generation capacities by country:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal electricity generation capacities (MW): "  /;
PUT "--------------------------------------------------------------------------------"//;
INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT (SUM((IA,IGKE)$ICA(C,IA), GKFX(Y,IA,IGKE))):12:0 ;
   )  PUT /; );

PUT //;

/*
* A table containing the sum of derated
* electricity generation capacities by country:

PUT "--------------------------------------------------------------------------------"/;
PUT "Derated (by first season value of GKDERATE) electricity generation capacities -- LIDT FORSKLLIGT HER " "(MW): "  /;

PUT "--------------------------------------------------------------------------------"//;
INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C, LOOP(S$(ORD(S) EQ 1),
     PUT (SUM((IA,IGKE)$ICA(C,IA), GKFX(Y,IA,IGKE)*GKDERATEST(IGKE,IA,'S52_01','T1'))):12:0 ;
   ) )PUT /;);
PUT //;

*/



* A table containing the sum of nominal electricity generation
* capacities by region:


PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal electricity generation capacities (MW): "  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(IR, PUT IR.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(IR,
     PUT (SUM((IA,IGKE)$RRRAAA(IR,IA), GKFX(Y,IA,IGKE))):12:0 ;
   )  PUT /; );

PUT //;




* A table containing the nominal electricity generation capacities by country:
* The table will not print out nicely if there are too many different
* technologies for a country.

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal electricity generation capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

ALIAS(Y,YINPUTOUT);
put "NB: Verify how this is calculated (CHP, HYRS, HYRR, WND, SOL ) "/;
LOOP(C,

PUT C.TL    /;

INPUTOUT.LJ = 1;
PUT "      " ;
 LOOP(IGKE,
     IF((SUM((Y,IA)$ICA(C,IA), GKFX(Y,IA,IGKE)) GT 0),
     PUT IGKE.TL:OTLG));PUT /;
INPUTOUT.LJ = 2;
LOOP(YINPUTOUT,
   PUT YINPUTOUT.TL:6
   LOOP(IGKE,
       IF((SUM((Y,IA)$ICA(C,IA), GKFX(Y,IA,IGKE)) GT 0),
           PUT (SUM((IA)$ICA(C,IA), GKFX(YINPUTOUT,IA,IGKE))):OTLG:0)  );PUT /;
   );
  PUT //;
* End LOOPC, :
);

PUT //;



* A table containing nominal condensing generation capacities (MW),
* by (Y,C)

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal condensing generation capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGCND)$ICA(C,IA), GKFX(Y,IA,IGCND))    ):12:0 ;
       ) PUT /;
   );
PUT //;



* A table containing nominal CHP generation capacities (MW), by (Y,C)

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal CHP generation capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGEXT)$ICA(C,IA), GKFX(Y,IA,IGEXT))
      + SUM((IA,IGBPR)$ICA(C,IA), GKFX(Y,IA,IGBPR))  ):12:0 ;
       ) PUT /;
   );
PUT //;



* A table containing heat storage capacities by (A)

LOOP(Y$(ORD(Y) EQ 1),
PUT "--------------------------------------------------------------------------------"/;
PUT "Heat storage capacities: storage (MWh), loading (MW) and unloading (MW), " Y.TL:4 /;
PUT "--------------------------------------------------------------------------------"//;

PUT "                               Storage (MWh)    Loading (MW)  Unloading (MW) "/;
LOOP(C,
LOOP(IA$(ICA(C,IA)  AND (SUM(IGHSTO,GKFX(Y,IA,IGHSTO)) GT 0)),
PUT IA.TL:16 ;
LOOP(IGHSTO$(GKFX(Y,IA,IGHSTO) GT 0),
PUT  IGHSTO.TL:12  GKFX(Y,IA,IGHSTO):16:1
                 (GKFX(Y,IA,IGHSTO)/GDATA(IGHSTO,'GDSTOHLOAD')):16:1
                 (GKFX(Y,IA,IGHSTO)/GDATA(IGHSTO,'GDSTOHUNLD')):16:1 /;
)));
);
PUT //;


* A table containing electricity storage capacities by (A)

LOOP(Y$(ORD(Y) EQ 1),
PUT "--------------------------------------------------------------------------------"/;
PUT "Electricity storage capacities: storage (MWh), loading (MW) and unloading (MW), " Y.TL:4 /;
PUT "--------------------------------------------------------------------------------"//;

PUT "                               Storage (MWh)    Loading (MW)  Unloading (MW) "/;
LOOP(C,
LOOP(IA$(ICA(C,IA)  AND (SUM(IGESTO,GKFX(Y,IA,IGESTO)) GT 0)),
PUT IA.TL:16 ;
LOOP(IGESTO$(GKFX(Y,IA,IGESTO) GT 0),
PUT  IGESTO.TL:12  GKFX(Y,IA,IGESTO):16:1;
IF((GDATA(IGESTO,'GDSTOHLOAD') GT 0), PUT (GKFX(Y,IA,IGESTO)/GDATA(IGESTO,'GDSTOHLOAD')):16:1;
ELSE PUT " ***Error: GDATA(IGESTO,'GDSTOHLOAD') is 0*** ";);
IF((GDATA(IGESTO,'GDSTOHUNLD') GT 0), PUT (GKFX(Y,IA,IGESTO)/GDATA(IGESTO,'GDSTOHUNLD')):16:1 /;
ELSE PUT " ***Error: GDATA(IGESTO,'GDSTOHUNLD') is 0*** "/;);
)));
);
PUT //;



* Full load hours for renewable energies, comparison between FLH and VAR values.
PUT "--------------------------------------------------------------------------------"/;
PUT "Full load hours for hydro, wind and solar energy sources, as given in the" /;
PUT "FLH-parameters and as calculated from the VAR-parameters, respectively: " /;
PUT "--------------------------------------------------------------------------------"//;

PUT "               ........WTRRS.........  ........WTRRR.........  " ".........WND..........  .........SOLE......... "/;
PUT "                  given    calculated     given    calculated  " "   given    calculated     given    calculated  "/;
OSCALAR1=0;
LOOP(C,
PUT C.TL:10 ":" /;
LOOP(IA$ICA(C,IA),
PUT IA.TL:12 ":";
PUT WTRRSFLH(IA):12:0;
IF((SMAX(S,WTRRSVAR_S(IA,S)) GT EPS),
PUT (SUM(T,IHOURSIN24(T))*IWTRRSSUM(IA)/(SMAX(S,WTRRSVAR_S(IA,S)))):14:0
ELSE PUT "             -"; OSCALAR1=OSCALAR1+1);
PUT WTRRRFLH(IA):10:0;
IF((SMAX((S,T),WTRRRVAR_T(IA,S,T)) GT EPS),
PUT (IWTRRRSUM(IA)/(SMAX((S,T),WTRRRVAR_T(IA,S,T)))):14:0
ELSE PUT "             -"; OSCALAR1=OSCALAR1+1);
PUT WNDFLH(IA):10:0;
IF((SMAX((S,T),WND_VAR_T(IA,S,T)) GT EPS),
PUT (IWND_SUMST(IA)/(SMAX((S,T),WND_VAR_T(IA,S,T)))):14:0
ELSE PUT "             -"; OSCALAR1=OSCALAR1+1);
PUT SOLEFLH(IA):10:0;
IF((SMAX((S,T),SOLE_VAR_T(IA,S,T)) GT EPS),
PUT (ISOLESUMST(IA)/(SMAX((S,T),SOLE_VAR_T(IA,S,T)))):14:0;
ELSE PUT "             -"; OSCALAR1=OSCALAR1+1);
PUT " SMAX WTRRSVAR_S : " (SMAX(S,WTRRSVAR_S(IA,S))):12:1  " SMAX WTRRRVAR_T : " ( SMAX((S,T),WTRRRVAR_T(IA,S,T))):12:1 ;
put /;
));
IF((OSCALAR1 GT 1), PUT "'-' indicates that all values in the profile are too close to 0." /;);
PUT //;










*$ONTEXT
** hans : dette er quickanddirtytilpasning!!!, melle udkommenterere $ontgerxt/$offext
* A table containing the sum of all hydro generation capacities and energy  by country:


LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;
PUT "Hydro power:" /;
PUT "For hydro power with storage:   Storage capacity (GWh), nominal water energy available one year (GWh) and hydro power capacity (MW) " Y.TL:4 ":" /;
PUT "For hydro power run-of-river:   Nominal water energy available one year (GWh) and hydro power capacity (MW) " Y.TL:4 ":" /;
PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" //;

PUT "              ..................Storage.............            ..........Run-of-river......"/;
PUT "                    GWh      GWh        MW        MW                 GWh        MW        MW"/;
PUT "                                   Nominal   Derated                       Nominal   Derated" /;


LOOP(C,
LOOP(IR$CCCRRR(C,IR),
PUT IR.TL ;
* IGHYRS:
   PUT  (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRS, /*HYRSRSFLH(IA)*/WTRRSFLH(IA)*GKFX(Y,IA,IGHYRS)))/IOF1000):10:0;
   PUT  (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRS, GKFX(Y,IA,IGHYRS)* WTRRSFLH(IA)))/IOF1000):10:0  ;
   PUT  (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRS, GKFX(Y,IA,IGHYRS)))):10:0 ;
   LOOP(S$(ORD(S) EQ 1),
*   PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRS, GKFX(Y,IA,IGHYRS)*GKDERATEST(IGHYRS,IA,'S52_01','T1')))):10:0
   PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRS, GKFX(Y,IA,IGHYRS)*GKDERATE(IA,IGHYRS,S)))):10:0
    ; );
PUT "          ";
* IGHYRR:
PUT  (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRR, GKFX(Y,IA,IGHYRR)* WTRRRFLH(IA)))/IOF1000):10:0  ;
     PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRR, GKFX(Y,IA,IGHYRR)))):10:0 ;
      LOOP(S$(ORD(S) EQ 1),
*     PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRR, GKFX(Y,IA,IGHYRR)*GKDERATEST(IGHYRR,IA,'S52_01','T1')))):10:0
     PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGHYRR, GKFX(Y,IA,IGHYRR)*GKDERATE(IA,IGHYRR,S)))):10:0
     ; );
PUT /;
));
PUT //;
);
PUT //;



* A table containing hydro power with storage:  Minimum and maximal storage capacity limits by region and season:

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;
PUT "Hydro power with storage:  Maximal and minimal storage capacity limits (GWh), " Y.TL:4 ":" /;
PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" //;

PUT "                                   ";
LOOP(S, PUT S.TL:12); PUT /;
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
  PUT IR.TL:12     ": Max (GWh): ";
   LOOP(S, PUT  (SUM(IA$RRRAAA(IR,IA), SUM(IGHYRS,HYRSDS(IA ,'HYRSDRSMAX',S) * /*HYRSRSFLH(IA)*/WTRRSFLH(IA)*GKFX(Y,IA,IGHYRS)))/IOF1000):12:0); PUT/;
  PUT "            : Min (GWh): ";
   LOOP(S, PUT  (SUM(IA$RRRAAA(IR,IA), SUM(IGHYRS,HYRSDS(IA ,'HYRSDRSMIN',S) * /*HYRSRSFLH(IA)*/WTRRSFLH(IA)*GKFX(Y,IA,IGHYRS)))/IOF1000):12:0); PUT/;
)));
PUT //;

$ONTEXT
* A table containing inflow to hydro power storage by region and season:

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;
PUT "Hydro power with storage:  Inflow by region and season (GWh), " Y.TL:4 ":" /;
PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" //;

INPUTOUT.LJ=1;
PUT "            ";
LOOP(S, PUT S.TL:12); PUT"         Sum" /;
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
  PUT IR.TL:12  ;
   LOOP(S,      PUT (SUM(IA$RRRAAA(IR,IA), SUM(IGHYRS, IHYINF_S(IA,IGHYRS,S)*GKFX(Y,IA,IGHYRS)))/IOF1000):12:0    );
   PUT (SUM(S, SUM(IA$RRRAAA(IR,IA), SUM(IGHYRS, IHYINF_S(IA,IGHYRS,S)*GKFX(Y,IA,IGHYRS))))/IOF1000):12:0;
PUT/;
)));
PUT //;







* A table containing inflow to hydro power storage by region and season:

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" /;
PUT "Hydro power run-of-river:  Inflow by region and season (GWh), " Y.TL:4 ":" /;
PUT "-------------------------------------------------------------------------------------------------------------------------------------------------------------------------" //;
INPUTOUT.LJ=1;
PUT "            ";
LOOP(S, PUT S.TL:12); PUT"         Sum" /;
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
  PUT IR.TL:12  ;
   LOOP(S, PUT (SUM(IA$RRRAAA(IR,IA), SUM(IGHYRR, IHYINF_S(IA,IGHYRR,S)*GKFX(Y,IA,IGHYRR)))/IOF1000):12:0);
   PUT (SUM(S, SUM(IA$RRRAAA(IR,IA), SUM(IGHYRR, IHYINF_S(IA,IGHYRR,S)*GKFX(Y,IA,IGHYRR))))/IOF1000):12:0;
PUT/;
)));
PUT //;


$OFFTEXT
*$OFFTEXT

* A table containing the sum of all hydro with pumped storage generation capacities, by (Y,C):

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal hydro power with pumped storage capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

$ONTEXT

IF((CARD(IGHYPMG) + CARD(IGHYPMP) GT 0),
INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGHYPMG)$ICA(C,IA), GKFX(Y,IA,IGHYPMG))   ):12:0 ;
       ) PUT /;
);
ELSE
PUT "None"/;
);

PUT //;
$OFFTEXT

* A table containing the sum of all hydro with reservoir generation capacities, by (Y,C):

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal hydro power with reservoir capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGHYRS)$ICA(C,IA), GKFX(Y,IA,IGHYRS))   ):12:0 ;
       ) PUT /;
   );
PUT //;

* A table containing the sum of all hydro with run-of-river generation capacities, by (Y,C):

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal hydro power with run-of-river capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGHYRR)$ICA(C,IA), GKFX(Y,IA,IGHYRR))   ):12:0 ;
       ) PUT /;
   );
PUT //;





$ontext
* A table containing the sum of all wind capacities and energy by country:

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "--------------------------------------------------------------------------------" /;
PUT "Nominal wind energy available one year (GWh) and wind power capacity (MW) "Y.TL:4 ":" /;
PUT "--------------------------------------------------------------------------------" //;

PUT "                   GWh        MW                 GWh        MW " /;
PUT "              Nominal capacities            Derated capacities " /;
LOOP(IR,
PUT IR.TL
   (SUM(IA$RRRAAA(IR,IA),SUM(IGWND, GKFX(Y,IA,IGWND)
    *GDATA(IGWND,"GFE")*8760/IOF1000))):10:0  ;
     PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGWND, GKFX(Y,IA,IGWND)))):10:0 ;
     PUT  "          ";
     LOOP(S$(ORD(S) EQ 1),
     PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGWND, GKFX(Y,IA,IGWND)*GKDERATEST(IGWND,IA,'S52_01','T1')
    *GDATA(IGWND,"GFE")*8760/IOF1000))):10:0  ; );
     LOOP(S$(ORD(S) EQ 1),
     PUT (SUM(IA$RRRAAA(IR,IA),SUM(IGWND, GKFX(Y,IA,IGWND)*GKDERATEST(IGWND,IA,'S52_01','T1')))):10:0
     /;  );
);
PUT //;
);
$offtext


* A table containing the sum of all wind power capacities, by (Y,C):

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal wind power capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGWND)$ICA(C,IA), GKFX(Y,IA,IGWND))   ):12:0 ;
       ) PUT /;
   );
PUT //;


*$OFFTEXT


* A table containing the sum of all heat generation capacities by country:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heat capacities (including CHP, excluding storage) (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT
       (SUM((IA,IGKHNOSTO)$ICA(C,IA), GKFX(Y,IA,IGKHNOSTO))
     + (SUM((IA,IGBPR)$ICA(C,IA), GKFX(Y,IA,IGBPR)/GDATA(IGBPR,"GDCB")))
     + (SUM((IA,IGEXT)$ICA(C,IA), GKFX(Y,IA,IGEXT)/(GDATA(IGEXT,"GDCB")+GDATA (IGEXT,"GDCV")))
       )):12:0 ;
       ) PUT /;
   );

PUT //;




* A table containing the sum of all heat generation capacities by area:


PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heat capacities (including CHP, excluding storage) (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      "  LOOP(IA, PUT IA.TL:12) ;PUT /;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6;
   LOOP(IA,
   PUT
       (SUM(IGKHNOSTO, GKFX(Y,IA,IGKHNOSTO))
     + (SUM(IGBPR, GKFX(Y,IA,IGBPR)/GDATA (IGBPR,"GDCB")))
     + (SUM(IGEXT, GKFX(Y,IA,IGEXT)/(GDATA (IGEXT,"GDCB")+GDATA (IGEXT,"GDCV")))
       )):12:0 ; );
        PUT /;
   );
PUT //;




* A table containing the sum of CHP electricity generation capacities by area:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal electricity capacities of CHP (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      "  LOOP(IA, PUT IA.TL:12) ;PUT /;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6;
   LOOP(IA,
   PUT
       (
*SUM(IGKHNOSTO, GKFX(Y,IA,IGKHNOSTO))
*     +
       (SUM(IGBPR, GKFX(Y,IA,IGBPR)))
     + (SUM(IGEXT, GKFX(Y,IA,IGEXT))
       )):12:0 ; );
        PUT /;
   );
PUT //;



* A table containing the sum of CHP heat generation capacities by area:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heat capacities of CHP (excluding heat pumps) (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      "  LOOP(IA, PUT IA.TL:12) ;PUT /;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6;
   LOOP(IA,
   PUT
       (
*SUM(IGKHNOSTO, GKFX(Y,IA,IGKHNOSTO))
*     +
       (SUM(IGBPR, GKFX(Y,IA,IGBPR)/GDATA (IGBPR,"GDCB")))
     + (SUM(IGEXT, GKFX(Y,IA,IGEXT)/(GDATA (IGEXT,"GDCB")+GDATA (IGEXT,"GDCV")))
       )):12:0 ; );
        PUT /;
   );
PUT //;




* A table containing the sum of nominal heat-only boiler generation
* capacities by country:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heat-only boiler capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT (SUM((IA,IGHOB)$ICA(C,IA), GKFX(Y,IA,IGHOB))):12:0 ;
   )  PUT /; );

PUT //;



* A table containing the sum of nominal heatpumps generation
* capacities by country:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heatpump capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6
   LOOP(C,
     PUT (SUM((IA,IGETOH)$ICA(C,IA), GKFX(Y,IA,IGETOH))):12:0 ;
   )  PUT /; );

PUT //;



* A table containing the sum of nominal heat-only boiler generation
* capacities by area:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heat-only boiler capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "      " ;LOOP(IA, PUT IA.TL:12) ;PUT /;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6;
   LOOP(IA, PUT (SUM(IGHOB, GKFX(Y,IA,IGHOB))):12:0 ; );
   )  PUT /;

PUT //;





* A table containing the sum of nominal heatpump generation
* capacities by area:

PUT "--------------------------------------------------------------------------------"/;
PUT "Nominal heatpump capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

* Table should be divided into two parts, if lines are too long:
OSCALAR2=12;  /* Dividing after OSCALAR2 areas */
* First half:
INPUTOUT.LJ = 1;
PUT "      " ;   OSCALAR1=0; LOOP(IA, OSCALAR1=OSCALAR1+1;
                 IF((OSCALAR1 LE OSCALAR2), PUT IA.TL:12)) ;PUT /;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6;
   OSCALAR1=0; LOOP(IA, OSCALAR1=OSCALAR1+1;
                 IF((OSCALAR1 LE OSCALAR2),
     PUT (SUM(IGETOH, GKFX(Y,IA,IGETOH))):12:0 ; );
   )  PUT /; );

PUT /;

IF(((OSCALAR2+1) LE OSCALAR1),
* Second half:
INPUTOUT.LJ = 1;
PUT "      " ; OSCALAR1=0; LOOP(IA, OSCALAR1=OSCALAR1+1;
                 IF(((OSCALAR2+1) LE OSCALAR1), PUT IA.TL:12)) ;PUT /;
INPUTOUT.LJ = 2;

LOOP(Y,
   PUT Y.TL:6;
   OSCALAR1=0; LOOP(IA, OSCALAR1=OSCALAR1+1;
                 IF(((OSCALAR2+1) LE OSCALAR1),
     PUT (SUM(IGETOH, GKFX(Y,IA,IGETOH))):12:0 ;);
   )  PUT /; );
);
PUT //;



PUT "--------------------------------------------------------------------------------"/;
PUT "Technologies available or not available for new investments:"  /;
PUT "--------------------------------------------------------------------------------"//;

PUT "The following technologies are available for new investments (but maybe not from"/;
PUT "the first year, and maybe not even during simulation period, cf. the table below)"/;
OSCALAR2=8;  /*Maximum number of labels per line*/
OSCALAR1=0; PUT "  ";
LOOP(IGKFIND,  OSCALAR1=OSCALAR1+1;
IF((OSCALAR1 LE OSCALAR2), PUT IGKFIND.TL:OTLG;
ELSE  OSCALAR1=0; PUT /; PUT "  ";); )
PUT //;

PUT "Consult the tables below for details about where and when the technologies"/;
PUT "become available."//;

PUT "The following technologies are in the model, but not available for new investments:"  /;
OSCALAR1=0;
LOOP(IGKKNOWN,  OSCALAR1=OSCALAR1+1;
IF((OSCALAR1 LE OSCALAR2), PUT IGKKNOWN.TL:OTLG ;
ELSE  OSCALAR1=0; PUT /;PUT "  ";); )
PUT ////;


PUT "--------------------------------------------------------------------------------"/;
PUT "Description of when new technologies may be invested" /;
PUT "--------------------------------------------------------------------------------"//;


OSCALAR3=8; /*Maximum number of labels per line*/
LOOP(Y,
IF((ORD(Y) EQ 1),
PUT "The following technologies are available for investments in the first year, "Y.TL:4":"/;
OSCALAR2=0;
LOOP(IGKFIND$((GDATA(IGKFIND,'GDFROMYEAR') LE YVALUE(Y))),
PUT IGKFIND.TL:OTLG;
OSCALAR2=OSCALAR2+1;
IF((OSCALAR2 GT OSCALAR3), PUT /; OSCALAR2=0;);
); PUT/;);
OSCALAR2=0;
IF((ORD(Y) GE 2),
PUT "The following additional technologies become available from the beginning of "Y.TL:4":";
LOOP(IGKFIND$((GDATA(IGKFIND,'GDFROMYEAR') EQ YVALUE(Y))),
IF((OSCALAR2 EQ 0),PUT /);
PUT IGKFIND.TL:OTLG;
OSCALAR2=OSCALAR2+1;
IF((OSCALAR2 GT OSCALAR3), OSCALAR2=0);
);
PUT /;
));
PUT //;



PUT "--------------------------------------------------------------------------------"/;
PUT "Description of where new generation technologies may be invested - Part 1" /;
PUT "--------------------------------------------------------------------------------"//;

OSCALAR1=12; /* Maximal number of technology labels per line */
LOOP(C,
PUT C.TL:15 ":"/;
LOOP(IA$ICA(C,IA),
PUT IA.TL:15 ": " ;
OSCALAR2=0;
LOOP(IGKFIND$IAGKN(IA,IGKFIND),
IF(OSCALAR2 LT OSCALAR1,
   PUT IGKFIND.TL:OTLG ;
   OSCALAR2=OSCALAR2+1;
ELSE
   PUT /; PUT "                 ";
   PUT IGKFIND.TL:OTLG ;
   OSCALAR2=1;
   )
) PUT /)
PUT /;)
PUT //;


PUT "--------------------------------------------------------------------------------"/;
PUT "Description of where new generation technologies may be invested - Part 2" /;
PUT "--------------------------------------------------------------------------------"//;

OSCALAR1=12; /* Maximal number of technology labels per line */
LOOP(IGKFIND,
PUT IGKFIND.TL:OTLG ": " ;
OSCALAR2=0;
LOOP(C,
LOOP(IA$(ICA(C,IA) AND IAGKN(IA,IGKFIND)),
IF(OSCALAR2 LT OSCALAR1,
   PUT IA.TL:15 ;
   OSCALAR2=OSCALAR2+1;
ELSE
    PUT /; PUT "    " OTLG.TS;
   PUT IA.TL:15 ;
   OSCALAR2=1;
   )
) )
PUT /;)
PUT //;






PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"/;
PUT "----------------------------- Section (500): -----------------------------------"/;
PUT "Tables relative to fuels: " /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"//;

* Tables containing fuel potentials.
* Fuel potentials by (F,C):
PUT "--------------------------------------------------------------------------------"/;
PUT "Fuel potentials and already installed capacities at country level (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;


INPUTOUT.LJ = 1;
PUT "                             "; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(FFF$(SUM(C,FKPOT(C,FFF))+SUM(IR,FKPOT(IR,FFF))+SUM(IA,FKPOT(IA,FFF))),
PUT FFF.TL /;
PUT "Potential: specified on C    " ;
*LOOP(C$FKPOT(C,FFF),
LOOP(C,
   IF(FKPOT(C,FFF),
     IF((FKPOT(C,FFF)<IOF0001), PUT  "           0";
     ELSE  PUT FKPOT(C,FFF):12:0;
     )
   ELSE PUT "         inf";);
); PUT /;

PUT "Potential: sum-of-regions    " ;
*LOOP(C$FKPOT(C,FFF),
LOOP(C,
   ISCALAR1=SUM(IR$CCCRRR(C,IR), FKPOT(IR,FFF) );
   IF(ISCALAR1,
     IF((ISCALAR1<IOF0001), PUT  "           0";
     ELSE  PUT ISCALAR1:12:0;
     )
   ELSE PUT "         inf";);
); PUT /;

PUT "Potential: sum-of-areas      " ;
*LOOP(C$FKPOT(C,FFF),
LOOP(C,
   ISCALAR1=SUM(IA$ICA(C,IA), FKPOT(IA,FFF) );
   IF(ISCALAR1,
     IF((ISCALAR1<IOF0001), PUT  "           0";
     ELSE  PUT ISCALAR1:12:0;
     )
   ELSE PUT "         inf";);
); PUT /;


PUT "Installed:                   " /;
LOOP(Y,
*PUT Y.TL:12;     LOOP(C$FKPOT(C,FFF), PUT
PUT Y.TL:12 "                 ";     LOOP(C, PUT
*hansrev2.14 ud       (SUM(G$(GDATA(G,'GDFUEL') EQ FDATA(FFF,'FDNB')),
       (SUM(G$IGF(G,FFF),
        SUM(IA$ICA(C,IA),  GKFX(Y,IA,G) ))):12:0 ); PUT /;
   ); PUT  /;   );
PUT //;



* Fuel potentials by (F,IR):
PUT "--------------------------------------------------------------------------------"/;
PUT "Fuel potentials and already installed capacities at region level (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

INPUTOUT.LJ = 1;
PUT "                             "; LOOP(IR, PUT IR.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(FFF$SUM(IR,FKPOT(IR,FFF)+SUM(IA,FKPOT(IA,FFF))),
PUT FFF.TL /;
PUT "Potential: specified on R    " ;
LOOP(IR,
   IF(FKPOT(IR,FFF),
     IF((FKPOT(IR,FFF)<IOF0001), PUT  "           0";
     ELSE  PUT FKPOT(IR,FFF):12:0;
     )
   ELSE PUT "         inf";);
); PUT /;


PUT "Potential: sum-of-areas      " ;
LOOP(IR,
   ISCALAR1=SUM(IA$RRRAAA(IR,IA), FKPOT(IA,FFF) );
   IF(ISCALAR1,
     IF((ISCALAR1<IOF0001), PUT  "           0";
     ELSE  PUT ISCALAR1:12:0;
     )
   ELSE PUT "         inf";);
); PUT /;





*LOOP(IR$SUM(IFFFALIAS,FKPOT(IR,IFFFALIAS)),
* IF(FKPOT(IR,FFF), PUT  FKPOT(IR,FFF):12:0, Else PUT  "          NA":12:0 )
*); PUT /;
PUT "Installed  " /;
LOOP(Y,
PUT Y.TL:12 "                 ";     LOOP(IR, PUT
*PUT Y.TL:12;     LOOP(IR$SUM(IFFFALIAS,FKPOT(IR,IFFFALIAS)), PUT
*hansrev2.14 ud         (SUM(G$(GDATA(G,'GDFUEL') EQ FDATA(FFF,'FDNB')),
       (SUM(G$IGF(G,FFF),
        SUM(IA$RRRAAA(IR,IA),  GKFX(Y,IA,G) ))):12:0 ); PUT /;
   ); PUT  /;   );
PUT //;


* Fuel potentials by (F,IA):
PUT "--------------------------------------------------------------------------------"/;
PUT "Fuel potentials and already installed capacities at area level (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

* Table should be divided into two parts, if lines are too long:

OSCALAR2=1000;  /* Dividing after OSCALAR2 areas. (made ineffective by setting large; second half not correct now.) */
* First half
INPUTOUT.LJ = 1;
PUT "            "; OSCALAR1=0; LOOP(IA, OSCALAR1=OSCALAR1+1;
*PUT "            "; OSCALAR1=0; LOOP(IA$SUM(FFF,FKPOT(IA,FFF)), OSCALAR1=OSCALAR1+1;
                 IF((OSCALAR1 LE OSCALAR2), PUT IA.TL:12)) ;PUT /;


INPUTOUT.LJ = 2;
LOOP(FFF,
*LOOP(FFF$SUM(IA,FKPOT(IA,FFF)),
PUT FFF.TL /;
PUT "Potential   " ;    OSCALAR1=0; LOOP(IA, OSCALAR1=OSCALAR1+1;
*PUT "Potential   " ;    OSCALAR1=0; LOOP(IA$SUM(IFFFALIAS,FKPOT(IA,IFFFALIAS)), OSCALAR1=OSCALAR1+1;
                        IF((OSCALAR1 LE OSCALAR2),
*IF(FKPOT(IA,FFF), PUT  FKPOT(IA,FFF):12:0, Else PUT  "          NA":12:0 ))) ;PUT /;
   IF(FKPOT(IA,FFF),
     IF((FKPOT(IA,FFF)<IOF0001), PUT  "           0";
     ELSE  PUT FKPOT(IA,FFF):12:0;
     )
   ELSE PUT "         inf";);
)); PUT /;


PUT "Installed  " /;
LOOP(Y,
PUT Y.TL:12;
 OSCALAR1=0;
 LOOP(IA, OSCALAR1=OSCALAR1+1; IF((OSCALAR1 LE OSCALAR2),
* LOOP(IA$SUM(IFFFALIAS,FKPOT(IA,IFFFALIAS)), OSCALAR1=OSCALAR1+1; IF((OSCALAR1 LE 12),
*hansrev2.14 ud       PUT (SUM(G$(GDATA(G,'GDFUEL') EQ FDATA(FFF,'FDNB')),
                PUT (SUM(G$IGF(G,FFF),
          GKFX(Y,IA,G) )):12:0 );
     ) ;
PUT /;
);  PUT /;);
PUT //;

IF(((OSCALAR2+1) LE OSCALAR1),
* Second half:
INPUTOUT.LJ = 1;
PUT "            "; OSCALAR1=0; LOOP(IA$SUM(FFF,FKPOT(IA,FFF)), OSCALAR1=OSCALAR1+1;
                    IF(((OSCALAR2+1) LE OSCALAR1), PUT IA.TL:12)) ;PUT /;
INPUTOUT.LJ = 2;
LOOP(FFF$SUM(IA,FKPOT(IA,FFF)),
PUT FFF.TL /;
PUT "Potential   " ;    OSCALAR1=0; LOOP(IA$SUM(IFFFALIAS,FKPOT(IA,IFFFALIAS)), OSCALAR1=OSCALAR1+1;
                        IF(((OSCALAR2+1) LE OSCALAR1), IF(FKPOT(IA,FFF), PUT  FKPOT(IA,FFF):12:0, Else PUT  "          NA":12:0 ))) ;PUT /;
PUT "Installed  " /;
LOOP(Y,
PUT Y.TL:12;     OSCALAR1=0; LOOP(IA$SUM(IFFFALIAS,FKPOT(IA,IFFFALIAS)), OSCALAR1=OSCALAR1+1; IF(((OSCALAR2+1) LE OSCALAR1),
*hansrev2.14 ud       PUT (SUM(G$(GDATA(G,'GDFUEL') EQ FDATA(FFF,'FDNB')),
                 PUT (SUM(G$IGF(G,FFF),
          GKFX(Y,IA,G) )):12:0 );
   );
PUT /;
); PUT /;);
)
PUT //;








* Tables containing fuel potentials.
* Fuel potentials by (F,C):
PUT "--------------------------------------------------------------------------------"/;
PUT "Exogenously specified technology capacities by fuel and country (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;


INPUTOUT.LJ = 1;
PUT "            "; LOOP(C, PUT C.TL:12) ;PUT //;
INPUTOUT.LJ = 2;

LOOP(FFF,
PUT FFF.TL /;
*PUT "Potential   " ;    LOOP(C, IF(FKPOT(C,FFF), PUT  FKPOT(C,FFF):12:0, Else PUT  "          NA":12:0 )); PUT /;
LOOP(Y, PUT Y.TL;
  LOOP(C,         PUT SUM(G$IGF(G,FFF),SUM(IA$ICA(C,IA), GKFX(Y,IA,G))):12:0;  )
PUT /;
));



PUT "--------------------------------------------------------------------------------"/;
PUT "Exogenously specified technology capacities by fuel and area (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;


LOOP(FFF,
PUT FFF.TL  /;
LOOP(Y,
  PUT "   " Y.TL:4 ":" /;
  LOOP(C,
    ISCALAR3= SUM(G$IGF(G,FFF),SUM(IA$ICA(C,IA), GKFX(Y,IA,G)));
    IF(ISCALAR3,
      LOOP(IR$CCCRRR(C,IR),
        ISCALAR2=SUM(G$IGF(G,FFF), SUM(IA$RRRAAA(IR,IA), GKFX(Y,IA,G)));
        IF(ISCALAR2,
          PUT "      " C.TL:12 IR.TL:12 /;
          LOOP(IA$RRRAAA(IR,IA),
             ISCALAR1=SUM(G$IGF(G,FFF), GKFX(Y,IA,G));
             IF(ISCALAR1,
                PUT "         " IA.TL:18;
                PUT ISCALAR1:12:0;
                PUT "     From technologies: ";
                LOOP(G$(IGF(G,FFF) AND GKFX(Y,IA,G)), PUT G.TL:24 );
                PUT /;
))))))));


PUT "--------------------------------------------------------------------------------"/;
PUT "Description of the fuel that each technology uses" /;
PUT "--------------------------------------------------------------------------------"//;


LOOP(G,
PUT G.TL:OTLG;
IF((GDATA(G,'GDFUEL') EQ 0), PUT "-" /;
ELSE
*hans rev 2.14 ud    LOOP(FFF$(GDATA(G,'GDFUEL') EQ FDATA(FFF,'FDNB')), PUT FFF.TL:32 /);
    LOOP(FFF$IGF(G,FFF),  PUT FFF.TL:32 );
PUT /;
));
PUT //;






PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"/;
PUT "----------------------------- Section (600): -----------------------------------"/;
PUT "Tables relative to economy: "/;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"//;


PUT "--------------------------------------------------------------------------------"/;
PUT "The currency used in output"/;
PUT "--------------------------------------------------------------------------------"//;
PUT "   The currency used in output is "OMONEY.ts " with the rate "OMONEY:5:2" to the input currency."/;
PUT //;




* A table containing the marginal costs of electricity generation, by (IR):
SET OIUNITSET / OIUNIT1 * OIUNIT140 /;
ALIAS(OIUNITSET,OIUNITST2);
SET OIGSET1(G);
SET OIGSET2(G);
SET OITEMPSET /OIMWNOM,OIMWADJ,OIFUELCOST,OIOAM,OIFUELTAX,OIEMISSTAX,OISUMCOST /;
PARAMETER OITAKEN(G);
SCALAR OISCALAR1, OISCALAR2, OISCALAR3, OISCALAR4;
PARAMETER OICOST(OIUNITSET,OITEMPSET);
PARAMETER OISUMCOST(G);

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "--------------------------------------------------------------------------------"/;
PUT "Variable costs of electricity generation on installed capacities, "Y.TL:4":"/;
PUT "The table contains all units in IGKE."/;
PUT "For all types of units the costs are calculated as the variable costs in the "/;
PUT "equation QOBJ. For CHP units the capacity is calculated as maximum electricity "/;
PUT "capacity, disregarding heat aspects."/;
PUT "--------------------------------------------------------------------------------"//;


LOOP(C,
PUT C.TL ":" /;
LOOP(IR$CCCRRR(C,IR),
LOOP(IA$RRRAAA(IR,IA),
PUT PUT IR.TL:13 IA.TL:13 ":" ;
OIGSET1(IGKE)=NO;
OIGSET2(IGKE)=NO;

* Find relevant units and their total variable cost (excl. tax):
LOOP(IGKE, IF((GKFX(Y,IA,IGKE) GT 0),
  OIGSET1(IGKE)=YES; OIGSET2(IGKE)=YES;
*hans rev.2.14 ud  LOOP(FFF$((GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDNB')) OR (GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDACRONYM'))),
  LOOP(FFF$IGF(IGKE,FFF),
  OISCALAR3= IOF3P6 *
 (FUELPRICE(Y,IA,FFF)/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)));

*test put ".*. FP=" FUELPRICE(Y,IA,FFF) ",div="(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) ;
);


*test put " .." OISCALAR3 ;

  OISCALAR3=OISCALAR3+GOMVCOST(IA,IGKE);
*test put " ..." OISCALAR3 ;
*test put " ...." OISCALAR3 ;
* Add emission taxes
  OISCALAR3 = OISCALAR3 +
    M_POL(Y,'TAX_CO2',C)*(IM_CO2(IGKE)/IOF1000)*IOF3P6/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) +
    M_POL(Y,'TAX_SO2',C)*(IM_SO2(IGKE)/IOF1000)*IOF3P6/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) +
    M_POL(Y,'TAX_NOX',C)*(GDATA(IGKE,'GDNOX')/IOF1000)*IOF3P6 /
      (GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE));

*test put " ....." OISCALAR3 ;
* Add fuel taxes
*hans rev2.14  ud  OISCALAR3 = OISCALAR3 + SUM(FFF$(GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDNB')),
  OISCALAR3 = OISCALAR3 + SUM(FFF$IGF(IGKE,FFF),
    TAX_F(FFF,C) * IOF3P6 /(GDATA(IGKE,'GDFE') * GEFFDERATE(IA,IGKE)) );
*test put " ......" OISCALAR3 ;
  OISUMCOST(IGKE)=OISCALAR3;
));


OITAKEN(OIGSET2)=0;
OISCALAR2=0;
INPUTOUT.LJ=1;


LOOP(OIGSET1,
 OISCALAR2=OISCALAR2+1;
 IF(OISCALAR2 GT CARD(OIUNITSET),
   PUT //;
   PUT "Error: the number of units in SET OIUNITSET is too small ";
   PUT "and therefore the present table is invalid. " /;
   PUT "Change SET OIUNITSET in INPUTOUT.INC to hold";
   PUT " at least "OISCALAR2:4:0" members. "//;
   );
* Find least cost among remaining:
 OISCALAR1=INF;
 LOOP(OIGSET2,
 IF((OISUMCOST(OIGSET2) LT OISCALAR1) AND (OITAKEN(OIGSET2) EQ 0),
    OISCALAR1=OISUMCOST(OIGSET2);
   ));
* Print one label, fix sequence and transfer values:
  OISCALAR4=0;
  LOOP(OIGSET2,
   IF(((OISUMCOST(OIGSET2) EQ OISCALAR1) AND (OITAKEN(OIGSET2) EQ 0)
      AND (OISCALAR4 EQ 0)),
    OISCALAR4=1;
    OITAKEN(OIGSET2)=1;
    PUT OIGSET2.TL:OTLG ;
* Transfer: to  /OIMWNOM,OIMWADJ,OIFUELCOST,OIOAM,OIFUELTAX,OIEMISSTAX,OISUMCOST /;
*    OICOST(OIUNITSET,'OIMWNOM')$(ORD(OIUNITSET) EQ OISCALAR2)=GKFX(Y,IA,OIGSET2);
 LOOP(OIUNITSET$(ORD(OIUNITSET) EQ OISCALAR2), OICOST(OIUNITSET,'OIMWNOM')=GKFX(Y,IA,OIGSET2));
    OICOST(OIUNITSET,'OIMWADJ')$(ORD(OIUNITSET) EQ OISCALAR2)=NA;
*hans rev 2.14 ud    LOOP(FFF$(GDATA(OIGSET2,'GDFUEL') EQ FDATA(FFF,'FDNB')),
    LOOP(FFF$IGF(OIGSET2,FFF),
      OISCALAR3= IOF3P6 *
       (FUELPRICE(Y,IA,FFF)/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2))));
      OICOST(OIUNITSET,'OIFUELCOST')$(ORD(OIUNITSET) EQ OISCALAR2) =OISCALAR3;
      OICOST(OIUNITSET,'OIOAM')$(ORD(OIUNITSET) EQ OISCALAR2)=GOMVCOST(IA,OIGSET2);
      OICOST(OIUNITSET,'OIFUELTAX')$(ORD(OIUNITSET) EQ OISCALAR2) =
*hans rev.2.14 ud       SUM(FFF$(GDATA(OIGSET2,'GDFUEL') EQ FDATA(FFF,'FDNB')),
       SUM(FFF$IGF(OIGSET2,FFF),
       TAX_F(FFF,C) * IOF3P6 / (GDATA(OIGSET2,'GDFE') * GEFFDERATE(IA,OIGSET2)) );
      OICOST(OIUNITSET,'OIEMISSTAX')$(ORD(OIUNITSET) EQ OISCALAR2) =
      (M_POL(Y,'TAX_CO2',C)*(IM_CO2(OIGSET2)/IOF1000)*IOF3P6/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) +
       M_POL(Y,'TAX_SO2',C)*(IM_SO2(OIGSET2)/IOF1000)*IOF3P6/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) +
       M_POL(Y,'TAX_NOX',C)*(GDATA(OIGSET2,'GDNOX')/IOF1000)*IOF3P6 /
       (GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) );
      OICOST(OIUNITSET,'OISUMCOST')$(ORD(OIUNITSET) EQ OISCALAR2) =
        OICOST(OIUNITSET,'OIFUELCOST')$(ORD(OIUNITSET) EQ OISCALAR2)
       +OICOST(OIUNITSET,'OIOAM')$(ORD(OIUNITSET) EQ OISCALAR2)
       +OICOST(OIUNITSET,'OIFUELTAX')$(ORD(OIUNITSET) EQ OISCALAR2)
       +OICOST(OIUNITSET,'OIEMISSTAX')$(ORD(OIUNITSET) EQ OISCALAR2);
   ))
);

PUT /;
INPUTOUT.LJ=2;

* Print nominal capacities, adjusted capacities, and the various cost components:

PUT "Capacity, nominal     (MW):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT OICOST(OIUNITSET,'OIMWNOM'):OTLG:0); PUT /;
PUT "Fuel cost      "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIFUELCOST')):OTLG:3);  PUT /;
PUT "Oper-Maint.cost"  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIOAM')):OTLG:3); PUT /;
PUT "Fuel tax       "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIFUELTAX')):OTLG:3);PUT /;
PUT "Emission tax   "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIEMISSTAX')):OTLG:3);PUT /;
PUT "Total cost     "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OISUMCOST')):OTLG:3); PUT //;
)));
);
PUT /;

*-------------------------------------------------------------------------------
*lige en lille test /*sns*/
*-------------------------------------------------------------------------------

OITAKEN(IGKH)=0;
OICOST(OIUNITSET,OITEMPSET)=0;
OISUMCOST(G)=0;
OISCALAR1 = 0;
OISCALAR2 = 0;
OISCALAR3 = 0;
OISCALAR4 = 0;

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),
*LARS: Udkommenteret
*DISPLAY IGKH;
PUT "--------------------------------------------------------------------------------"/;
PUT "Variable costs of heat generation on installed capacities, "Y.TL:4":"/;
PUT "The table contains all units in IGKH."/;
PUT "For all types of units the costs are calculated as the variable costs in the "/;
PUT "equation QOBJ."/;
PUT "--------------------------------------------------------------------------------"//;


LOOP(C,
PUT C.TL ":" /;
LOOP(IR$CCCRRR(C,IR),
LOOP(IA$RRRAAA(IR,IA),
PUT PUT IR.TL:13 IA.TL:13 ":" ;
OIGSET1(G)=NO;
OIGSET2(G)=NO;

* Find relevant units and their total variable cost (excl. tax):
LOOP(IGKH, IF((GKFX(Y,IA,IGKH) GT 0),
  OIGSET1(IGKH)=YES; OIGSET2(IGKH)=YES;
*hans rev.21.4 ud   LOOP(FFF$(GDATA(IGKH,'GDFUEL') EQ FDATA(FFF,'FDNB')),
  LOOP(FFF$IGF(IGKH,FFF),
  OISCALAR3= IOF3P6 *
 (FUELPRICE(Y,IA,FFF)/(GDATA(IGKH,'GDFE')*GEFFDERATE(IA,IGKH))));
  OISCALAR3=OISCALAR3+GOMVCOST(IA,IGKH);

* Emission taxes
  OISCALAR3 = OISCALAR3 +
    M_POL(Y,'TAX_CO2',C)*(IM_CO2(IGKH)/IOF1000)*IOF3P6/(GDATA(IGKH,'GDFE')*GEFFDERATE(IA,IGKH)) +
    M_POL(Y,'TAX_SO2',C)*(IM_SO2(IGKH)/IOF1000)*IOF3P6/(GDATA(IGKH,'GDFE')*GEFFDERATE(IA,IGKH)) +
    M_POL(Y,'TAX_NOX',C)*(GDATA(IGKH,'GDNOX')/IOF1000)*IOF3P6 /
      (GDATA(IGKH,'GDFE')*GEFFDERATE(IA,IGKH));

* Fuel taxes
*hans rev.2.14 ud  OISCALAR3 = OISCALAR3 + SUM(FFF$(GDATA(IGKH,'GDFUEL') EQ FDATA(FFF,'FDNB')),
  OISCALAR3 = OISCALAR3 + SUM(FFF$IGF(IGKH,FFF),
    TAX_F(FFF,C) * IOF3P6 /(GDATA(IGKH,'GDFE') * GEFFDERATE(IA,IGKH)) );

  OISUMCOST(IGKH)=OISCALAR3;
));


OITAKEN(OIGSET2)=0;
OISCALAR2=0;
INPUTOUT.LJ=1;


LOOP(OIGSET1,
 OISCALAR2=OISCALAR2+1;
 IF(OISCALAR2 GT CARD(OIUNITSET),
   PUT //;
   PUT "Error: the number of units in SET OIUNITSET is too small ";
   PUT "and therefore the present table is invalid. " /;
   PUT "Change SET OIUNITSET in INPUTOUT.INC to hold";
   PUT " at least "OISCALAR2:4:0" members. "//;
   );
* Find least cost among remaining:
 OISCALAR1=INF;
 LOOP(OIGSET2,
 IF((OISUMCOST(OIGSET2) LT OISCALAR1) AND (OITAKEN(OIGSET2) EQ 0),
    OISCALAR1=OISUMCOST(OIGSET2);
   ));
* Print one label, fix sequence and transfer values:
  OISCALAR4=0;
  LOOP(OIGSET2,
   IF(((OISUMCOST(OIGSET2) EQ OISCALAR1) AND (OITAKEN(OIGSET2) EQ 0)
      AND (OISCALAR4 EQ 0)),
    OISCALAR4=1;
    OITAKEN(OIGSET2)=1;
    PUT OIGSET2.TL:OTLG ;
* Transfer: to  /OIMWNOM,OIMWADJ,OIFUELCOST,OIOAM,OIFUELTAX,OIEMISSTAX,OISUMCOST /;
*    OICOST(OIUNITSET,'OIMWNOM')$(ORD(OIUNITSET) EQ OISCALAR2)=GKFX(Y,IA,OIGSET2);
 LOOP(OIUNITSET$(ORD(OIUNITSET) EQ OISCALAR2), OICOST(OIUNITSET,'OIMWNOM')=GKFX(Y,IA,OIGSET2));
    OICOST(OIUNITSET,'OIMWADJ')$(ORD(OIUNITSET) EQ OISCALAR2)=NA;
*hans rev.2.14 ud    LOOP(FFF$(GDATA(OIGSET2,'GDFUEL') EQ FDATA(FFF,'FDNB')),
    LOOP(FFF$IGF(OIGSET1,FFF),
      OISCALAR3= IOF3P6 *
       (FUELPRICE(Y,IA,FFF)/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2))));
      OICOST(OIUNITSET,'OIFUELCOST')$(ORD(OIUNITSET) EQ OISCALAR2) =OISCALAR3;
      OICOST(OIUNITSET,'OIOAM')$(ORD(OIUNITSET) EQ OISCALAR2)=GOMVCOST(IA,OIGSET2);
      OICOST(OIUNITSET,'OIFUELTAX')$(ORD(OIUNITSET) EQ OISCALAR2) =
*hans rev.21.4 ud       SUM(FFF$(GDATA(OIGSET2,'GDFUEL') EQ FDATA(FFF,'FDNB')),
       SUM(FFF$IGF(OIGSET1,FFF),
       TAX_F(FFF,C) * IOF3P6 / (GDATA(OIGSET2,'GDFE') * GEFFDERATE(IA,OIGSET2)) );
      OICOST(OIUNITSET,'OIEMISSTAX')$(ORD(OIUNITSET) EQ OISCALAR2) =
      (M_POL(Y,'TAX_CO2',C)*(IM_CO2(OIGSET2)/IOF1000)*IOF3P6/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) +
       M_POL(Y,'TAX_SO2',C)*(IM_SO2(OIGSET2)/IOF1000)*IOF3P6/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) +
       M_POL(Y,'TAX_NOX',C)*(GDATA(OIGSET2,'GDNOX')/IOF1000)*IOF3P6 /
       (GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) );
      OICOST(OIUNITSET,'OISUMCOST')$(ORD(OIUNITSET) EQ OISCALAR2) =
        OICOST(OIUNITSET,'OIFUELCOST')$(ORD(OIUNITSET) EQ OISCALAR2)
       +OICOST(OIUNITSET,'OIOAM')$(ORD(OIUNITSET) EQ OISCALAR2)
       +OICOST(OIUNITSET,'OIFUELTAX')$(ORD(OIUNITSET) EQ OISCALAR2)
       +OICOST(OIUNITSET,'OIEMISSTAX')$(ORD(OIUNITSET) EQ OISCALAR2);
   ))
);

PUT /;
INPUTOUT.LJ=2;

* Print nominal capacities, adjusted capacities, and the various cost components:

PUT "Capacity, nominal     (MW):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT OICOST(OIUNITSET,'OIMWNOM'):OTLG:0); PUT /;
PUT "Fuel cost      "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIFUELCOST')):OTLG:3);  PUT /;
PUT "Oper-Maint.cost"  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIOAM')):OTLG:3); PUT /;
PUT "Fuel tax       "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIFUELTAX')):OTLG:3);PUT /;
PUT "Emission tax   "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OIEMISSTAX')):OTLG:3);PUT /;
PUT "Total cost     "  "("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
 PUT (OMONEY*OICOST(OIUNITSET,'OISUMCOST')):OTLG:3); PUT //;
)));
);
PUT /;


*-------------------------------------------------------------------------------


SET OESUPPSTEP /OESUPP0001 * OESUPP1000 /;                      /*sns*/
PARAMETER OESUPPCURV(RRR,OESUPPSTEP);
SCALAR OISCALAR5;


* A table containing the marginal costs of electricity generation, by (IR):
SET OIAGSET1(AAA,G);
SET OIAGSET2(AAA,G);
PARAMETER OIAGTAKEN(AAA,G);
PARAMETER OIAGSUMCST(AAA,G);

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

LOOP(C,
LOOP(IR$CCCRRR(C,IR),
OIAGSET1(AAA,G)=NO;
OIAGSET2(AAA,G)=NO;


* Find relevant units (to be placed in OIAGSET1 and OIAGSET1)
* and their total variable cost (to be placed in OIAGSUMCST):
LOOP(IGKE, LOOP(IA$RRRAAA(IR,IA),
IF((GKFX(Y,IA,IGKE) GT 0),
  OIAGSET1(IA,IGKE)=YES; OIAGSET2(IA,IGKE)=YES;
*hans rev.2.14 ud  LOOP(FFF$(GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDNB')),
  LOOP(FFF$IGF(IGKE,FFF),
  OISCALAR3= IOF3P6 *
 (FUELPRICE(Y,IA,FFF)/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE))));
  OISCALAR3=OISCALAR3+GOMVCOST(IA,IGKE);

* Emission taxes
  OISCALAR3 = OISCALAR3 +
    M_POL(Y,'TAX_CO2',C)*(IM_CO2(IGKE)/IOF1000)*IOF3P6/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) +
    M_POL(Y,'TAX_SO2',C)*(IM_SO2(IGKE)/IOF1000)*IOF3P6/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) +
    M_POL(Y,'TAX_NOX',C)*(GDATA(IGKE,'GDNOX')/IOF1000)*IOF3P6 /
      (GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE));

* Fuel taxes
*hans rev.2.14 ud  OISCALAR3 = OISCALAR3 + SUM(FFF$(GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDNB')),
  OISCALAR3 = OISCALAR3 + SUM(FFF$IGF(IGKE,FFF),
    TAX_F(FFF,C) * IOF3P6 /(GDATA(IGKE,'GDFE') * GEFFDERATE(IA,IGKE)) );

  OIAGSUMCST(IA,IGKE)=OISCALAR3;
)));



* Sort according to increasing costs:
OIAGTAKEN(OIAGSET2)=0;
OISCALAR2=0;

LOOP(OIAGSET1,
 OISCALAR2=OISCALAR2+1;
* Check that CARD(OIUNITSET) is big enough:
 IF(OISCALAR2 GT CARD(OIUNITSET),
   PUT //;
   PUT "Error: the number of units in SET OIUNITSET is too small ";
   PUT "and therefore the present table is invalid. " /;
   PUT "Change SET OIUNITSET in INPUTOUT.INC to hold";
   PUT " at least "OISCALAR2:4:0" members. "//;
   );
* Find least cost among remaining:
OISCALAR1=INF;
LOOP(OIAGSET2,
 IF((OIAGSUMCST(OIAGSET2) LT OISCALAR1) AND (OIAGTAKEN(OIAGSET2) EQ 0),
    OISCALAR1=OIAGSUMCST(OIAGSET2);
   ));

OISCALAR4=0;
LOOP(OIAGSET2,
  IF(((OIAGSUMCST(OIAGSET2) EQ OISCALAR1) AND (OIAGTAKEN(OIAGSET2) EQ 0)
     AND (OISCALAR4 EQ 0)),
   OISCALAR4=1;
   OIAGTAKEN(OIAGSET2)=1;

* Transfer to  /OIMWNOM, OIAGSUMCST /;
   OICOST(OIUNITSET,'OIMWNOM')$(ORD(OIUNITSET) EQ OISCALAR2)=GKFX(Y,OIAGSET2);
   OICOST(OIUNITSET,'OISUMCOST')$(ORD(OIUNITSET) EQ OISCALAR2)= OIAGSUMCST(OIAGSET2);
));
);




* Assemble the curve in OESUPPCURV for all regions, to be printed together later:
OISCALAR1=25; /*MW step length*/
/* OISCALAR2 is the number of units*/
OISCALAR3=0;  /*Accumulated MW including present unit*/
OISCALAR4=0;  /*Accumulated MW, discretised*/
OISCALAR5=0;  /*Position in discretised curve OESUPPCURV*/

LOOP(OIUNITSET$(ORD(OIUNITSET) LE OISCALAR2),
  OISCALAR3=OISCALAR3+OICOST(OIUNITSET,'OIMWNOM');

  LOOP(OESUPPSTEP$(((ORD(OESUPPSTEP)*OISCALAR1) GT OISCALAR4) AND
                   ((ORD(OESUPPSTEP)*OISCALAR1) LE OISCALAR3) AND
                   (ORD(OESUPPSTEP) LE CARD(OESUPPSTEP))),

    IF((ORD(OESUPPSTEP) LT CARD(OESUPPSTEP)),
      OESUPPCURV(IR,OESUPPSTEP) = (OMONEY*OICOST(OIUNITSET,'OISUMCOST'));
    ELSE
      OESUPPCURV(IR,OESUPPSTEP) = NA;
    );
  );

  OISCALAR4=OISCALAR3;
);

OESUPPCURV(IR,OESUPPSTEP)$((ORD(OESUPPSTEP)*OISCALAR1) GT OISCALAR3)=-INF;
));
);  /* End of LOOP(Y$((ORD(Y) EQ 1), ... */
PUT /;



LOOP(Y$(ORD(Y) EQ 1),
INPUTOUT.LJ=1;
PUT "--------------------------------------------------------------------------------"/;
PUT "Electricity supply curve by region: "/;
PUT "Based on variable costs of electricity generation on installed capacities, "Y.TL:4"." /;
PUT "The table contains all units in IGKE."/
PUT "For all types of units the costs are calculated as in the equation QOBJ." /;
PUT "For CHP units the capacity is calculated as maximum electricity capacity,"/;
PUT "disregarding heat aspects, and disregarding energy and fuel constraints."/;
PUT "Due to the discretisation, production units with capacities less than " OISCALAR1:3:0 " MW " /;
PUT "may be neglected, and the supply may be reduced. "/;
PUT "--------------------------------------------------------------------------------"//;
);

PUT /;
PUT "          MW";
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
PUT IR.TL:12 ));
PUT /;



LOOP(OESUPPSTEP,
OISCALAR3=0;
LOOP(IR, IF((-INF LT OESUPPCURV(IR,OESUPPSTEP)), OISCALAR3=OISCALAR1+3));
IF((0 LT OISCALAR3),
PUT (OISCALAR1*ORD(OESUPPSTEP)):12:0;/*OISCALAR1 is MW step length, see above*/
LOOP(C,
LOOP(IR$CCCRRR(C,IR),
IF((-INF LT OESUPPCURV(IR,OESUPPSTEP)),
PUT OESUPPCURV(IR,OESUPPSTEP):12;
ELSE
* Here choose (by commenting in/out) either (not both!) if nothing shall be printed:
* PUT "            ";);
* ... or if some character (usefull if e.g. to be imported to Excel) shall be printed:
PUT "           -";);
));
PUT /;
));

IF(SUM((IR,OESUPPSTEP)$(ORD(OESUPPSTEP) EQ CARD(OESUPPSTEP)),OESUPPCURV(IR,OESUPPSTEP)) EQ NA,
PUT "The NA here indicates that not all the supply curve is printed." /;);
PUT //;




SET OITEMPSET2 /OIOAMF,OIINVCOST,OIFUELCOST,OIOAMV,OIFUELTAX,OIEMISSTAX,OISUMCOST,OI2000FLH,OI4000FLH,OI6000FLH/;
PARAMETER OIGFLH(G);
PARAMETER OICOST2(OIUNITSET,OITEMPSET2);

LOOP(Y$((ORD(Y) EQ 1) /* OR (ORD(Y) EQ CARD(Y))*/ ),

PUT "--------------------------------------------------------------------------------"/;
PUT "Total costs of electricity generation (including investment costs) on all new "/;
PUT "capacities in the year "Y.TL:4":" //;
PUT "The table contains all units in given a '1' in GKVARIABLE in GDATA."/;
PUT "For all types of units the costs are calculated as in the equation QOBJ." /;
PUT "For CHP units the capacity is calculated as maximum electricity capacity, "/;
PUT "disregarding heat aspects. The costs are given for 2000 full load hours, "/;
PUT "4000 full load hours, and 6000 full load hours. They have been sorted by the "/;
PUT "costs of 4000 full load hours of production. Wind, hydro run-of-river, "/;
PUT "and solar units all have a given number of full load hours, that is used "/;
PUT "instead of 2000, 4000, or 6000. Thus the total cost of these units will be "/;
PUT "equal in the three cases. "/;
PUT /;
PUT "Note that only 18 entries will be printed for each area. " /;
PUT "--------------------------------------------------------------------------------"//;


INPUTOUT.LJ=2;


LOOP(C,
PUT C.TL ":" /;
LOOP(IR$CCCRRR(C,IR),
LOOP(IA$RRRAAA(IR,IA),
PUT IR.TL IA.TL "     :" ;
OIGSET1(IGKE)=NO;
OIGSET2(IGKE)=NO;

OIGFLH(G) = 4000;
OIGFLH(IGHYRS) = WTRRSFLH(IA);
OIGFLH(IGHYRR) = WTRRRFLH(IA);
OIGFLH(IGWND)  = WNDFLH(IA);
OIGFLH(IGSOLE) = SOLEFLH(IA);



$ontext
PUT "TESTLOOP: "/;
LOOP((IGKE,FFF)$(IGF(IGKE,FFF) ),
PUT C.TL IR.TL IA.TL IGKE.TL FFF.TL "GDKVARIABL:=" GDATA(IGKE,'GDKVARIABL')  " aGkn=" AGKN(IA,IGKE)  " ... "/;

/*         (       and (GDATA(IGKE,'GDKVARIABL') EQ 1)
              AND AGKN(IA,IGKE)
              AND ((not FKPOT(C,FFF)) or FKPOT(C,FFF) GE 0)
              AND ((not FKPOT(IR,FFF)) or FKPOT(IR,FFF) GE 0)
              AND ((not FKPOT(IA,FFF)) or FKPOT(IA,FFF) GE 0)   ) ,

*/

);
$offtext


* Find relevant units and their total variable cost (excl. tax):
LOOP((IGKE,FFF)$(IGF(IGKE,FFF)
* hans rev.2.14 ud((GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDNB')) OR (GDATA(IGKE,'GDFUEL') EQ FDATA(FFF,'FDACRONYM')))
              and (GDATA(IGKE,'GDKVARIABL') EQ 1)
              AND AGKN(IA,IGKE)
              AND ((not FKPOT(C,FFF)) or FKPOT(C,FFF) GE 0)
              AND ((not FKPOT(IR,FFF)) or FKPOT(IR,FFF) GE 0)
              AND ((not FKPOT(IA,FFF)) or FKPOT(IA,FFF) GE 0)   ) ,

  OIGSET1(IGKE)=YES; OIGSET2(IGKE)=YES;


* O&M costs, fixed (4000 FLH)
  OISCALAR3 = (GOMFCOST(IA,IGKE)*IOF1000 / OIGFLH(IGKE))$(OIGFLH(IGKE) GT 0) + INF$(OIGFLH(IGKE) EQ 0);

* Investment costs (4000 FLH)
  OISCALAR3 = OISCALAR3 +
  (ANNUITYC(C)*GDATA(IGKE,'GDINVCOST0')*IOF1000000 / OIGFLH(IGKE))$(OIGFLH(IGKE) GT 0)+ INF$(OIGFLH(IGKE) EQ 0);


* Fuel costs
  OISCALAR3 = OISCALAR3 + IOF3P6 *
    (FUELPRICE(Y,IA,FFF)/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)));

* O&M cost (variable)
  OISCALAR3 = OISCALAR3 + GOMVCOST(IA,IGKE);

* Emission taxes
  OISCALAR3 = OISCALAR3 +
    M_POL(Y,'TAX_CO2',C)*(IM_CO2(IGKE)/IOF1000)*IOF3P6/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) +
    M_POL(Y,'TAX_SO2',C)*(IM_SO2(IGKE)/IOF1000)*IOF3P6/(GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE)) +
    M_POL(Y,'TAX_NOX',C)*(GDATA(IGKE,'GDNOX')/IOF1000)*IOF3P6 /
      (GDATA(IGKE,'GDFE')*GEFFDERATE(IA,IGKE));

* Fuel taxes
  OISCALAR3 = OISCALAR3 +
    (TAX_F(FFF,C) * IOF3P6 /(GDATA(IGKE,'GDFE') * GEFFDERATE(IA,IGKE)));

  OISUMCOST(IGKE)=OISCALAR3;
);


OITAKEN(OIGSET2)=0;
OISCALAR2=0;
INPUTOUT.LJ=1;

OSCALAR1 = 1 ;
OSCALAR2 = 18 ; /* number of technologies listed for each line */

LOOP(OIGSET1,
 OISCALAR2=OISCALAR2+1;
 IF(OISCALAR2 GT CARD(OIUNITSET),
   PUT //;
   PUT "Error: the number of units in SET OIUNITSET is too small ";
   PUT "and therefore the present table is invalid. " /;
   PUT "Change SET OIUNITSET in INPUTOUT.INC to hold";
   PUT " at least "OISCALAR2:4:0" members. "//;
   );
* Find least cost among remaining:
 OISCALAR1=INF;
 LOOP(OIGSET2,
 IF((OISUMCOST(OIGSET2) LT OISCALAR1) AND (OITAKEN(OIGSET2) EQ 0),
    OISCALAR1=OISUMCOST(OIGSET2);
   ));
* Print one label, fix sequence and transfer values:
  OISCALAR4=0;
  LOOP(OIGSET2,
    IF(((OISUMCOST(OIGSET2) EQ OISCALAR1) AND (OITAKEN(OIGSET2) EQ 0)
      AND (OISCALAR4 EQ 0)),
    OISCALAR4=1;
    OITAKEN(OIGSET2)=1;
    PUT$(OSCALAR1 LE OSCALAR2) OIGSET2.TL:OTLG ;

* Transfer: to  /OIOAMF,OIINVCOST,OIFUELCOST,OIOAMV,OIFUELTAX,OIEMISSTAX,OISUMCOST,OI2000FLH,OI4000FLH,OI6000FLH/;

    LOOP(OIUNITSET$(ORD(OIUNITSET) EQ OISCALAR2), OICOST2(OIUNITSET,'OIOAMF')=GOMFCOST(IA,OIGSET2));

    LOOP(OIUNITSET$(ORD(OIUNITSET) EQ OISCALAR2), OICOST2(OIUNITSET,'OIINVCOST')=GDATA(OIGSET2,'GDINVCOST0'));

*hans rev.2.14 ud    LOOP(FFF$(GDATA(OIGSET2,'GDFUEL') EQ FDATA(FFF,'FDNB')),
    LOOP(FFF$IGF(OIGSET1,FFF),
      OISCALAR3 = IOF3P6 *
      (FUELPRICE(Y,IA,FFF)/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2))));
      OICOST2(OIUNITSET,'OIFUELCOST')$(ORD(OIUNITSET) EQ OISCALAR2) = OISCALAR3;

    OICOST2(OIUNITSET,'OIOAMV')$(ORD(OIUNITSET) EQ OISCALAR2)=GOMVCOST(IA,OIGSET2);

    OICOST2(OIUNITSET,'OIFUELTAX')$(ORD(OIUNITSET) EQ OISCALAR2) =
*hans rev.2.14 ud      SUM(FFF$(GDATA(OIGSET2,'GDFUEL') EQ FDATA(FFF,'FDNB')),
      SUM(FFF$IGF(OIGSET1,FFF),
      TAX_F(FFF,C) * IOF3P6 / (GDATA(OIGSET2,'GDFE') * GEFFDERATE(IA,OIGSET2)) );

    OICOST2(OIUNITSET,'OIEMISSTAX')$(ORD(OIUNITSET) EQ OISCALAR2) =
    ( M_POL(Y,'TAX_CO2',C)*(IM_CO2(OIGSET2)/IOF1000)*IOF3P6/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) +
      M_POL(Y,'TAX_SO2',C)*(IM_SO2(OIGSET2)/IOF1000)*IOF3P6/(GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) +
      M_POL(Y,'TAX_NOX',C)*(GDATA(OIGSET2,'GDNOX')/IOF1000)*IOF3P6 /
        (GDATA(OIGSET2,'GDFE')*GEFFDERATE(IA,OIGSET2)) );

    OICOST2(OIUNITSET,'OISUMCOST')$(ORD(OIUNITSET) EQ OISCALAR2) =
       OICOST2(OIUNITSET,'OIFUELCOST')
     + OICOST2(OIUNITSET,'OIOAMV')
     + OICOST2(OIUNITSET,'OIFUELTAX')
     + OICOST2(OIUNITSET,'OIEMISSTAX');

    OICOST2(OIUNITSET,'OI4000FLH')$(ORD(OIUNITSET) EQ OISCALAR2) =
      OICOST2(OIUNITSET,'OISUMCOST') +
      ((GOMFCOST(IA,OIGSET2)*IOF1000/OIGFLH(OIGSET2)) +
      (ANNUITYC(C)*GDATA(OIGSET2,'GDINVCOST0')*IOF1000000/OIGFLH(OIGSET2)))$(OIGFLH(OIGSET2) GT 0)
      + INF$(OIGFLH(OIGSET2) EQ 0);

    OIGFLH(OIGSET2)$(OIGFLH(OIGSET2) EQ 4000) = 2000;
    OIGFLH(IGHYRS) = WTRRSFLH(IA);
    OIGFLH(IGHYRR) = WTRRRFLH(IA);
    OIGFLH(IGWND) = WNDFLH(IA);
    OIGFLH(IGSOLE)= SOLEFLH(IA);

    OICOST2(OIUNITSET,'OI2000FLH')$(ORD(OIUNITSET) EQ OISCALAR2) =
      OICOST2(OIUNITSET,'OISUMCOST') +
      ((GOMFCOST(IA,OIGSET2)*IOF1000/OIGFLH(OIGSET2)) +
      (ANNUITYC(C)*GDATA(OIGSET2,'GDINVCOST0')*IOF1000000/OIGFLH(OIGSET2)))$(OIGFLH(OIGSET2) GT 0)
      + INF$(OIGFLH(OIGSET2) EQ 0);

    OIGFLH(OIGSET2)$(OIGFLH(OIGSET2) EQ 2000) = 6000;
    OIGFLH(IGHYRS) = WTRRSFLH(IA);
    OIGFLH(IGHYRR) = WTRRRFLH(IA);
    OIGFLH(IGWND)  = WNDFLH(IA);
    OIGFLH(IGSOLE) = SOLEFLH(IA);

    OICOST2(OIUNITSET,'OI6000FLH')$(ORD(OIUNITSET) EQ OISCALAR2) =
      OICOST2(OIUNITSET,'OISUMCOST') +
      ((GOMFCOST(IA,OIGSET2)*IOF1000/OIGFLH(OIGSET2)) +
      (ANNUITYC(C)*GDATA(OIGSET2,'GDINVCOST0')*IOF1000000/OIGFLH(OIGSET2)))$(OIGFLH(OIGSET2) GT 0)
      + INF$(OIGFLH(OIGSET2) EQ 0);
    );
  );
  OSCALAR1 = OSCALAR1 + 1;
);

PUT /;
INPUTOUT.LJ=2;



* Print the various fixed and variable cost components:

PUT "O&M cost (fixed)  (k"OMONEY.TS"/MW):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OIOAMF')):OTLG:3); PUT /;

PUT "Investment cost   (M"OMONEY.TS"/MW):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OIINVCOST')):OTLG:3); PUT /;

PUT "------------------------------"
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT OTLG.TS; ); PUT /;

PUT "Fuel cost         ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OIFUELCOST')):OTLG:3);  PUT /;

PUT "O&M cost (var)    ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OIOAMV')):OTLG:3); PUT /;

PUT "Fuel tax          ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OIFUELTAX')):OTLG:3);PUT /;

PUT "Emission tax      ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OIEMISSTAX')):OTLG:3);PUT /;

PUT "Total cost (var)  ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OISUMCOST')):OTLG:3); PUT /;

PUT "------------------------------"
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT OTLG.TS; ); PUT /;

PUT "Total (2000 FLH)  ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OI2000FLH')):OTLG:3);PUT /;

PUT "Total (4000 FLH)  ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OI4000FLH')):OTLG:3);PUT /;

PUT "Total (6000 FLH)  ("OMONEY.TS"/MWh):" ;
LOOP(OIUNITSET$((ORD(OIUNITSET) LE OISCALAR2) AND (ORD(OIUNITSET) LE OSCALAR2)),
 PUT (OMONEY*OICOST2(OIUNITSET,'OI6000FLH')):OTLG:3); PUT //;

)));
);
PUT //;




PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"/;
PUT "----------------------------- Section (700): -----------------------------------"/;
PUT "Tables relative to electricity transmission: " /;
PUT "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"//;


* Transmission capacities by (IR,IR):
PUT "--------------------------------------------------------------------------------"/;
PUT "Initial transmission capacities (MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

LOOP(Y,
PUT Y.TL:4 ":" /;
INPUTOUT.LJ=1;
PUT "    To:     "; LOOP(IRI, PUT IRI.TL:12 ); PUT /;
INPUTOUT.LJ=2;
PUT "From:" /;
OSCALAR1=0;
LOOP(IRE,
OSCALAR1=OSCALAR1+1;
PUT IRE.TL:12 ;
OSCALAR2=0;
LOOP(IRI,
 OSCALAR2=OSCALAR2+1;
 IF((OSCALAR1 EQ OSCALAR2),
       PUT "           -";
 ELSE PUT XKINI(Y,IRE,IRI):12:0 ));
PUT /;
);
PUT /;
);




* Transmission capacities by (IR,IR):
PUT "--------------------------------------------------------------------------------"/;
PUT "Possibilities for new transmission capacities and associated costs (Money/MW):"  /;
PUT "--------------------------------------------------------------------------------"//;

* Note: the printing assumes that the upper half of the matrices IXKN and XINVCOST are zero.
IF((CARD(IXKN) EQ 0),
PUT "No new transmission capacities permitted."/;
ELSE
INPUTOUT.LJ=1;
PUT "    To:     "; LOOP(IRI, PUT IRI.TL:12 ); PUT /;
INPUTOUT.LJ=2;
PUT "From:" /;
OSCALAR1=0;
LOOP(IRE,
OSCALAR1=OSCALAR1+1;
PUT IRE.TL:12 ;
OSCALAR2=0;
LOOP(IRI,
 OSCALAR2=OSCALAR2+1;
 IF((OSCALAR1 EQ OSCALAR2),
       PUT "           -";
 ELSEIF((IXKN(IRE,IRI) or IXKN(IRI,IRE))),
PUT  (XINVCOST(IRE,IRI)+XINVCOST(IRI,IRE)):12:0
ELSE
PUT  "           -";

));
PUT /;
));
PUT //;

* End of file inputout.inc
